package com.noodlebox.util
{
	import com.noodlebox.util.*;
	
	import flash.display.*;
	import flash.events.*;
	import flash.geom.ColorTransform;
	import flash.geom.Matrix;
	import flash.media.Camera;
	import flash.media.Video;
	import flash.utils.Timer;
	
	public class CameraBitmapData extends BitmapData
	{
		
		public var camera:Camera, cameraVideo:Video;
		public var framesPerSecond:int, greyScale:Boolean, mirror:Boolean=false, alpha:Number, noScaling:Boolean=false;
		
		public var transform:Array = new Array;
		
		public var uniqueFrameID:uint = 0;
		
		public function CameraBitmapData(width:int,height:int, framesPerSecond:int, camOptimumWidth:int=-1 , camOptimumHeight:int=-1, greyScale:Boolean=false, mirror:Boolean=false, alpha:Number=1):void {
			
			super(width,height,false,0);
						
			// this needs updating as it doesn't follow the api behaviour of out-of-bounds camera image sizes
			
			if (camOptimumWidth == -1) {
				noScaling = true;
				camOptimumWidth = width;
			}
			
			if (camOptimumHeight == -1) {
				noScaling = true;
				camOptimumHeight = height;
			}
			
			this.alpha = alpha;
			this.framesPerSecond = framesPerSecond;
			this.mirror = mirror;
			this.greyScale = greyScale;
			
			cameraVideo = new Video( camOptimumWidth, camOptimumHeight );
			cameraVideo.smoothing = true;
			
			var camera:Camera = Camera.getCamera( );
			cameraVideo.attachCamera( camera );
			camera.setQuality(0,100);
			camera.setMode(camOptimumWidth,camOptimumHeight,framesPerSecond,false);
			camera.setKeyFrameInterval(1);
		
			var timer:Timer = new Timer(1000/framesPerSecond,0);
			timer.addEventListener(TimerEvent.TIMER, process);
			timer.start();
							
		}
		
		public function process(e:Event=null):void {
			
			var ct:ColorTransform = new ColorTransform(1,1,1,alpha);
			
			if (mirror) {
				
				var m:Matrix = new Matrix;
				m.scale(-width/cameraVideo.width,height/cameraVideo.height);
				m.translate(width,0);
				this.draw(cameraVideo,m,ct,null,null,true);
				
			} else {
				
				if (noScaling) {
					this.draw(cameraVideo,null,ct);
				} else {
					BitmapDataUtil.drawToFit(cameraVideo,this,ct,null,true);	
				}
				
			}
						
			if (greyScale) BitmapDataUtil.convertToGreyscale(this);
			
			// to do:implement cts etc
			
			for (var i:int=0 ; i<transform.length ; i++) {
				if (transform[i] is Function) transform[i](this);
			}
			
			uniqueFrameID = Math.random()*0xffffff;
			
		}
	
	}
	
}